## flashproxy 1.7

=== Makefile ===
# Makefile for a self-contained binary distribution of flashproxy-client.
#
# This builds two zipball targets, dist and dist-exe, for POSIX and Windows
# respectively. Both can be extracted and run in-place by the end user.
# (PGP-signed forms also exist, sign and sign-exe.)
#
# If you are a distro packager, instead see the separate build scripts for each
# source component, all of which have an `install` target:
# - client: Makefile.client
# - common: setup-common.py
# - facilitator: facilitator/{configure.ac,Makefile.am}
#
# It is possible to build dist-exe on GNU/Linux by using wine to install
# the windows versions of Python, py2exe, and m2crypto, then running
# `make PYTHON="wine python" dist-exe`.

PACKAGE = flashproxy-client
VERSION = $(shell sh version.sh)
DISTNAME = $(PACKAGE)-$(VERSION)

THISFILE = $(lastword $(MAKEFILE_LIST))
PYTHON = python

MAKE_CLIENT = $(MAKE) -f Makefile.client PYTHON="$(PYTHON)"
# don't rebuild man pages due to VCS giving spurious timestamps, see #9940
REBUILD_MAN = 0

# all is N/A for a binary package, but include for completeness
all:

install:
	$(MAKE_CLIENT) DESTDIR=$(DESTDIR) REBUILD_MAN=$(REBUILD_MAN) install
	$(PYTHON) setup-common.py install $(if $(DESTDIR),--root=$(DESTDIR))

DISTDIR = dist/$(DISTNAME)
$(DISTDIR): Makefile.client setup-common.py $(THISFILE)
	mkdir -p $(DISTDIR)
	$(MAKE_CLIENT) DESTDIR=$(DISTDIR) bindir=/ docdir=/ man1dir=/doc/ \
	  REBUILD_MAN="$(REBUILD_MAN)" install
	$(PYTHON) setup-common.py build_py -d $(DISTDIR)

dist/%.zip: dist/%
	cd dist && zip -q -r -9 "$(@:dist/%=%)" "$(<:dist/%=%)"

dist/%.zip.asc: dist/%.zip
	rm -f "$@"
	gpg --sign --detach-sign --armor "$<"
	gpg --verify "$@" "$<"

dist: force-dist $(DISTDIR).zip

sign: force-dist $(DISTDIR).zip.asc

PY2EXE_TMPDIR = py2exe-tmp
export PY2EXE_TMPDIR
$(PY2EXE_TMPDIR): setup-client-exe.py
	$(PYTHON) setup-client-exe.py py2exe -q

DISTDIR_W32 = $(DISTDIR)-win32
# below, we override DST_SCRIPT and DST_MAN1 for windows
$(DISTDIR_W32): $(PY2EXE_TMPDIR) $(THISFILE)
	mkdir -p $(DISTDIR_W32)
	$(MAKE_CLIENT) DESTDIR=$(DISTDIR_W32) bindir=/ docdir=/ man1dir=/doc/ \
	  DST_SCRIPT= DST_MAN1='$$(SRC_MAN1)' \
	  REBUILD_MAN="$(REBUILD_MAN)" install
	cp -t $(DISTDIR_W32) $(PY2EXE_TMPDIR)/dist/*

dist-exe: force-dist-exe $(DISTDIR_W32).zip

sign-exe: force-dist-exe $(DISTDIR_W32).zip.asc

# clean is N/A for a binary package, but include for completeness
clean: distclean

distclean:
	$(MAKE_CLIENT) clean
	$(PYTHON) setup-common.py clean --all
	rm -rf dist $(PY2EXE_TMPDIR)

test: check
check:
	$(MAKE_CLIENT) check
	$(PYTHON) setup-common.py test


test-full: test
	cd facilitator && \
	  { test -x ./config.status && ./config.status || \
	  { test -x ./configure || ./autogen.sh; } && ./configure; } \
	  && make && PYTHONPATH=.. make check
	cd proxy && make test

force-dist:
	rm -rf $(DISTDIR) $(DISTDIR).zip

force-dist-exe:
	rm -rf $(DISTDIR_W32) $(DISTDIR_W32).zip $(PY2EXE_TMPDIR)

.PHONY: all dist sign dist-exe sign-exe clean distclean test check test-full force-dist force-dist-exe

=== proxy/Makefile ===
LANGS = de en pt ru

all: $(addprefix badge-, $(addsuffix .png, $(LANGS)))

test:
	./flashproxy-test.js

badge-%.png: badge.xcf
	(cat badge-export-lang.scm; echo '(export "$*") (gimp-quit 0)') | gimp -i -b -

.PHONY: all test

=== proxy/modules/nodejs/Makefile ===
.PHONY: all prepublish
topsrcdir = ../../..

ALL_DST = flashproxy.js flashproxy.1
VERSION = $(shell sed -ne 's/^[[:space:]]*"version"[[:space:]]*:[[:space:]]*"\([^"][^"]*\)".*/\1/gp' package.json)

all: $(ALL_DST)

prepublish: flashproxy.js
flashproxy.js: $(topsrcdir)/proxy/flashproxy.js
	cp -f $< $@

flashproxy.1: main.js flashproxy.js $(topsrcdir)/mkman.sh $(topsrcdir)/mkman.inc Makefile
	./main.js --help | sed -e 's,node ./main.js,flashproxy,g' \
	  | $(topsrcdir)/mkman.sh flashproxy "$(VERSION)" "The flashproxy standalone nodejs proxy" "$(VERSION)" > "$@"

clean:
	rm -f $(ALL_DST)

=== debian/changelog ===
flashproxy (1.7-4) unstable; urgency=medium

  * Actually make the documentation build reproducibly.
  * Use the recently-decided standard variable SOURCE_DATE_EPOCH.

 -- Ximin Luo <infinity0@pwned.gg>  Wed, 17 Jun 2015 20:35:57 +0200

flashproxy (1.7-3) unstable; urgency=medium

  * Fix Vcs links.
  * Make the documentation build reproducibly.

 -- Ximin Luo <infinity0@pwned.gg>  Mon, 30 Mar 2015 22:03:21 +0200

flashproxy (1.7-2) unstable; urgency=medium

  * Fix build for slower machines. (Closes: #765156)
  * Update to latest Standards-Version. No changes required.
  * Run overlooked proxy tests in debian/rules.

 -- Ximin Luo <infinity0@pwned.gg>  Wed, 05 Nov 2014 17:19:56 +0000

flashproxy (1.7-1) unstable; urgency=low

  * Initial release. (Closes: #721845)

 -- Ximin Luo <infinity0@pwned.gg>  Wed, 06 Aug 2014 01:36:31 +0100

=== debian/control ===
Source: flashproxy
Maintainer: Ximin Luo <infinity0@pwned.gg>
Section: net
Priority: extra
Build-Depends: debhelper (>= 9),
 asciidoc,
 docbook-xsl,
 dh-autoreconf,
 dh-python,
 faketime,
 help2man (>= 1.47.1),
 nodejs,
 node-optimist,
 openssl,
 python,
 python-m2crypto,
 python-setuptools,
 xsltproc,
Standards-Version: 3.9.6
X-Python-Version: >= 2.7
Homepage: https://crypto.stanford.edu/flashproxy/
Vcs-Git: https://git.torproject.org/debian/flashproxy.git
Vcs-Browser: https://gitweb.torproject.org/debian/flashproxy.git

Package: flashproxy-common
Architecture: all
Section: python
Depends: ${misc:Depends}, ${python:Depends}
Description: Pluggable transport to circumvent IP address blocking - common library
 Flashproxy is a tool to circumvent censorship by setting up many, generally
 ephemeral, browser-based proxies, with the goal of outpacing a censor's
 ability to enumerate and block the IP addresses of those proxies. Censored
 clients can then connect to a Tor relay via these proxies, by using a
 hard-to-block, low-bandwidth registration system called the facilitator.
 .
 This package contains the common Python library used by other components.

Package: flashproxy-client
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, flashproxy-common (= ${binary:Version})
Description: Pluggable transport to circumvent IP address blocking - client transport plugin
 Flashproxy is a tool to circumvent censorship by setting up many, generally
 ephemeral, browser-based proxies, with the goal of outpacing a censor's
 ability to enumerate and block the IP addresses of those proxies. Censored
 clients can then connect to a Tor relay via these proxies, by using a
 hard-to-block, low-bandwidth registration system called the facilitator.
 .
 This package contains the client transport plugin that enables censored Tor
 users to circumvent censorship. It is compliant with the Tor pluggable
 transports specification.

Package: flashproxy-facilitator
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, flashproxy-common (= ${binary:Version}), openssl, adduser
Recommends: httpd-cgi | apache2
Suggests: flashproxy-proxy
Description: Pluggable transport to circumvent IP address blocking - facilitator
 Flashproxy is a tool to circumvent censorship by setting up many, generally
 ephemeral, browser-based proxies, with the goal of outpacing a censor's
 ability to enumerate and block the IP addresses of those proxies. Censored
 clients can then connect to a Tor relay via these proxies, by using a
 hard-to-block, low-bandwidth registration system called the facilitator.
 .
 This package contains the facilitator that accepts registrations (requests
 for service) from clients, and serves them with a browser proxy that provides
 access to a Tor relay.
 .
 Most end-users do not need to install this package.

Package: flashproxy-proxy
Architecture: all
Section: web
Depends: ${misc:Depends}
Recommends: httpd | apache2
Description: Pluggable transport to circumvent IP address blocking - browser proxy
 Flashproxy is a tool to circumvent censorship by setting up many, generally
 ephemeral, browser-based proxies, with the goal of outpacing a censor's
 ability to enumerate and block the IP addresses of those proxies. Censored
 clients can then connect to a Tor relay via these proxies, by using a
 hard-to-block, low-bandwidth registration system called the facilitator.
 .
 This package contains the browser proxy to be served from a web server.
 Visitors to this website can then act as ephemeral proxies for censored users.
 .
 Most end-users do not need to install this package.

Package: node-flashproxy
Architecture: all
Depends: ${misc:Depends}, flashproxy-proxy (= ${binary:Version}),
 nodejs, node-optimist, node-xmlhttprequest, node-ws
Description: Pluggable transport to circumvent IP address blocking - nodejs proxy
 Flashproxy is a tool to circumvent censorship by setting up many, generally
 ephemeral, browser-based proxies, with the goal of outpacing a censor's
 ability to enumerate and block the IP addresses of those proxies. Censored
 clients can then connect to a Tor relay via these proxies, by using a
 hard-to-block, low-bandwidth registration system called the facilitator.
 .
 This package contains a nodejs-based proxy to be run as a local service. It
 is for people that constantly want to act as proxies for censored users.
 Due to the design of the system, it more useful when installed on a machine
 that continually changes IP address, such as a laptop.
 .
 Most end-users do not need to install this package.

=== debian/rules ===
#!/usr/bin/make -f

# NOTE: debian/rules build (which runs tests) must be run outside of fakeroot
# since the tests open sockets, which fakeroot stubs out. In other words, you
# must run `debian/rules build` separately from `fakeroot debian/rules binary`.
# (The standard build tools such as dpkg-buildpackage already do this.)

%:
	dh $@ --with autoreconf,python2

DH_common = -S python_distutils
DH_client = -S makefile -- -f Makefile.client prefix=/usr sysconfdir=/etc
DH_facilitator = -S autoconf -D facilitator --
DH_proxy = -S makefile -D proxy --
DH_nodeproxy = -S makefile -D proxy/modules/nodejs --

# reproducible documentation
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog --count 1 -SDate)" +%s)
export PATH := $(CURDIR)/debian/strip-nondeterminism:$(PATH)

# TODO(infinity0): handle setup-common.py better; currently we symlink it as a
# hack. Ideally, we would fix dh_python to support custom setup.py filenames.

override_dh_install:
	dh_install -XChangeLog -XLICENSE -XMakefile

override_dh_fixperms:
	dh_fixperms
	chmod 600 debian/flashproxy-facilitator/etc/flashproxy/reg-email.pass

override_dh_auto_configure:
	ln -sf setup-common.py setup.py
	dh_auto_configure $(DH_facilitator) --enable-initscripts cgibindir=/usr/lib/cgi-bin

override_dh_auto_build:
	dh_auto_build $(DH_common)
	dh_auto_build $(DH_client)
	dh_auto_build $(DH_facilitator) PYTHONPATH=..
	dh_auto_build $(DH_nodeproxy)

override_dh_auto_test:
	dh_auto_test $(DH_common)
	dh_auto_test $(DH_client)
	dh_auto_test $(DH_facilitator) PYTHONPATH=.. VERBOSE=1
	dh_auto_test $(DH_proxy)

override_dh_auto_install:
	dh_auto_install $(DH_common)
	dh_auto_install $(DH_client)
	dh_auto_install $(DH_facilitator)
	for name in fp-facilitator fp-reg-decryptd fp-registrar-email; do \
	  dh_installinit -p flashproxy-facilitator -o --name=$${name}; \
	done

override_dh_auto_clean:
	ln -sf setup-common.py setup.py
	dh_auto_clean $(DH_common)
	rm -rf flashproxy_common.egg-info
	dh_auto_clean $(DH_client)
	dh_auto_clean $(DH_client) maintainer-clean
	dh_auto_clean $(DH_facilitator)
	dh_auto_clean $(DH_nodeproxy)
	rm -f setup.py

e2e-check:
	dpkg -s libparse-debcontrol-perl >/dev/null
	CHANGES="../flashproxy_$$(dpkg-parsechangelog -SVersion)_$$(dpkg --print-architecture).changes"; \
	if [ -f "$$CHANGES" ]; then \
		debian/flashproxy-end-to-end-test.sh "$$CHANGES"; \
	else \
		echo >&2 "did you built the package yet? file not found: $$CHANGES"; \
		false; \
	fi

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/\
  https://people.torproject.org/~dcf/flashproxy/flashproxy-(\d.+)\.tar\.gz
